Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblemData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblemData.cs	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblemData.cs	(revision 3442)
@@ -36,74 +36,122 @@
   [StorableClass]
   public class DataAnalysisProblemData : NamedItem {
+    [Storable]
+    private VariableCollection variables;
+    public VariableCollection Variables {
+      get { return variables; }
+    }
+
+    #region variable properties
+    public IVariable DatasetVariable {
+      get { return variables["Dataset"]; }
+    }
+
+    public IVariable TargetVariableVariable {
+      get { return variables["TargetVariable"]; }
+    }
+
+    public IVariable InputVariablesVariable {
+      get { return variables["InputVariables"]; }
+    }
+
+    public IVariable TrainingSamplesStartVariable {
+      get { return variables["TrainingSamplesStart"]; }
+    }
+    public IVariable TrainingSamplesEndVariable {
+      get { return variables["TrainingSamplesEnd"]; }
+    }
+
+    public IVariable TestSamplesStartVariable {
+      get { return variables["TestSamplesStart"]; }
+    }
+    public IVariable TestSamplesEndVariable {
+      get { return variables["TestSamplesEnd"]; }
+    }
+    #endregion
+
     #region properties
-    private Dataset dataset;
-    [Storable]
     public Dataset Dataset {
-      get { return dataset; }
-      set {
-        if (dataset != value) {
-          if (value == null) throw new ArgumentNullException();
-          else {
-            dataset = value;
-            OnDatasetChanged(EventArgs.Empty);
-          }
-        }
-      }
-    }
-    private StringValue targetVariable;
-    [Storable]
+      get { return (Dataset)DatasetVariable.Value; }
+      set {
+        if (value != Dataset) {
+          if (value == null) throw new ArgumentNullException();
+          if (Dataset != null) DeregisterDatasetEventHandlers();
+          DatasetVariable.Value = value;
+          RegisterDatasetEventHandlers();
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public StringValue TargetVariable {
-      get { return targetVariable; }
-      set { targetVariable = value; }
-    }
-    private ItemList<StringValue> inputVariables;
-    [Storable]
+      get { return (StringValue)TargetVariableVariable.Value; }
+      set {
+        if (value != TargetVariableVariable) {
+          if (value == null) throw new ArgumentNullException();
+          if (TargetVariable != null) DeregisterStringValueEventHandlers(TargetVariable);
+          TargetVariableVariable.Value = value;
+          RegisterStringValueEventHandlers(TargetVariable);
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public ItemList<StringValue> InputVariables {
-      get { return inputVariables; }
-      set {
-        if (inputVariables != value) {
-          if (value == null) throw new ArgumentNullException();
-          else {
-            inputVariables = value;
-            OnInputVariablesChanged(EventArgs.Empty);
-          }
-        }
-      }
-    }
-    private IntValue trainingSamplesStart;
-    [Storable]
+      get { return (ItemList<StringValue>)InputVariablesVariable.Value; }
+      set {
+        if (value != InputVariables) {
+          if (value == null) throw new ArgumentNullException();
+          if (InputVariables != null) DeregisterInputVariablesEventHandlers();
+          InputVariablesVariable.Value = value;
+          RegisterInputVariablesEventHandlers();
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public IntValue TrainingSamplesStart {
-      get { return trainingSamplesStart; }
-      set { trainingSamplesStart = value; }
-    }
-    private IntValue trainingSamplesEnd;
-    [Storable]
+      get { return (IntValue)TrainingSamplesStartVariable.Value; }
+      set {
+        if (value != TrainingSamplesStart) {
+          if (value == null) throw new ArgumentNullException();
+          if (TrainingSamplesStart != null) DeregisterValueTypeEventHandlers(TrainingSamplesStart);
+          TrainingSamplesStartVariable.Value = value;
+          RegisterValueTypeEventHandlers(TrainingSamplesStart);
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public IntValue TrainingSamplesEnd {
-      get { return trainingSamplesEnd; }
-      set { trainingSamplesEnd = value; }
-    }
-    private IntValue validationSamplesStart;
-    [Storable]
-    public IntValue ValidationSamplesStart {
-      get { return validationSamplesStart; }
-      set { validationSamplesStart = value; }
-    }
-    private IntValue validationSamplesEnd;
-    [Storable]
-    public IntValue ValidationSamplesEnd {
-      get { return validationSamplesEnd; }
-      set { validationSamplesEnd = value; }
-    }
-    private IntValue testSamplesStart;
-    [Storable]
+      get { return (IntValue)TrainingSamplesEndVariable.Value; }
+      set {
+        if (value != TrainingSamplesEnd) {
+          if (value == null) throw new ArgumentNullException();
+          if (TrainingSamplesEnd != null) DeregisterValueTypeEventHandlers(TrainingSamplesEnd);
+          TrainingSamplesEndVariable.Value = value;
+          RegisterValueTypeEventHandlers(TrainingSamplesEnd);
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public IntValue TestSamplesStart {
-      get { return testSamplesStart; }
-      set { testSamplesStart = value; }
-    }
-    private IntValue testSamplesEnd;
-    [Storable]
+      get { return (IntValue)TestSamplesStartVariable.Value; }
+      set {
+        if (value != TestSamplesStart) {
+          if (value == null) throw new ArgumentNullException();
+          if (TestSamplesStart != null) DeregisterValueTypeEventHandlers(TestSamplesStart);
+          TestSamplesStartVariable.Value = value;
+          RegisterValueTypeEventHandlers(TestSamplesStart);
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
+    }
     public IntValue TestSamplesEnd {
-      get { return testSamplesEnd; }
-      set { testSamplesEnd = value; }
+      get { return (IntValue)TestSamplesEndVariable.Value; }
+      set {
+        if (value != TestSamplesEnd) {
+          if (value == null) throw new ArgumentNullException();
+          if (TestSamplesEnd != null) DeregisterValueTypeEventHandlers(TestSamplesEnd);
+          TestSamplesEndVariable.Value = value;
+          RegisterValueTypeEventHandlers(TestSamplesEnd);
+          OnProblemDataChanged(EventArgs.Empty);
+        }
+      }
     }
     #endregion
@@ -111,13 +159,13 @@
     public DataAnalysisProblemData()
       : base() {
-      dataset = new Dataset();
-      targetVariable = new StringValue();
-      inputVariables = new ItemList<StringValue>();
-      trainingSamplesStart = new IntValue();
-      trainingSamplesEnd = new IntValue();
-      validationSamplesStart = new IntValue();
-      validationSamplesEnd = new IntValue();
-      testSamplesStart = new IntValue();
-      testSamplesEnd = new IntValue();
+      variables = new VariableCollection();
+      variables.Add(new Variable("Dataset", new Dataset()));
+      variables.Add(new Variable("InputVariables", new ItemList<StringValue>()));
+      variables.Add(new Variable("TargetVariable", new StringValue()));
+      variables.Add(new Variable("TrainingSamplesStart", new IntValue()));
+      variables.Add(new Variable("TrainingSamplesEnd", new IntValue()));
+      variables.Add(new Variable("TestSamplesStart", new IntValue()));
+      variables.Add(new Variable("TestSamplesEnd", new IntValue()));
+      RegisterEventHandlers();
     }
 
@@ -125,16 +173,120 @@
     private DataAnalysisProblemData(bool deserializing) : base() { }
 
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      RegisterEventHandlers();
+    }
+
     #region events
-    public event EventHandler InputVariablesChanged;
-    protected virtual void OnInputVariablesChanged(EventArgs e) {
-      var listeners = InputVariablesChanged;
+    private void RegisterEventHandlers() {
+      RegisterDatasetEventHandlers();
+      RegisterInputVariablesEventHandlers();
+      RegisterStringValueEventHandlers(TargetVariable);
+      RegisterValueTypeEventHandlers(TrainingSamplesStart);
+      RegisterValueTypeEventHandlers(TrainingSamplesEnd);
+      RegisterValueTypeEventHandlers(TestSamplesStart);
+      RegisterValueTypeEventHandlers(TestSamplesEnd);
+    }
+
+    public event EventHandler ProblemDataChanged;
+    protected virtual void OnProblemDataChanged(EventArgs e) {
+      var listeners = ProblemDataChanged;
       if (listeners != null) listeners(this, e);
     }
 
-    public event EventHandler DatasetChanged;
-    protected virtual void OnDatasetChanged(EventArgs e) {
-      EventHandler handler = DatasetChanged;
-      if (handler != null) handler(this, e);
-    }
+
+    private void RegisterValueTypeEventHandlers<T>(ValueTypeValue<T> value) where T : struct {
+      value.ValueChanged += new EventHandler(value_ValueChanged);
+    }
+
+    private void DeregisterValueTypeEventHandlers<T>(ValueTypeValue<T> value) where T : struct {
+      value.ValueChanged -= new EventHandler(value_ValueChanged);
+    }
+
+    void value_ValueChanged(object sender, EventArgs e) {
+      OnProblemDataChanged(e);
+    }
+
+    private void RegisterStringValueEventHandlers(StringValue value) {
+      value.ValueChanged += new EventHandler(value_ValueChanged);
+    }
+
+    private void DeregisterStringValueEventHandlers(StringValue value) {
+      value.ValueChanged -= new EventHandler(value_ValueChanged);
+    }
+
+    private void RegisterDatasetEventHandlers() {
+      Dataset.DataChanged += new EventHandler<EventArgs<int, int>>(Dataset_DataChanged);
+      Dataset.Reset += new EventHandler(Dataset_Reset);
+      Dataset.ColumnNamesChanged += new EventHandler(Dataset_ColumnNamesChanged);
+    }
+
+    private void DeregisterDatasetEventHandlers() {
+      Dataset.DataChanged -= new EventHandler<EventArgs<int, int>>(Dataset_DataChanged);
+      Dataset.Reset -= new EventHandler(Dataset_Reset);
+      Dataset.ColumnNamesChanged -= new EventHandler(Dataset_ColumnNamesChanged);
+    }
+
+    void Dataset_ColumnNamesChanged(object sender, EventArgs e) {
+      OnProblemDataChanged(e);
+    }
+
+    void Dataset_Reset(object sender, EventArgs e) {
+      OnProblemDataChanged(e);
+    }
+
+    void Dataset_DataChanged(object sender, EventArgs<int, int> e) {
+      OnProblemDataChanged(e);
+    }
+
+    private void RegisterInputVariablesEventHandlers() {
+      InputVariables.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_CollectionReset);
+      InputVariables.ItemsAdded += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsAdded);
+      InputVariables.ItemsRemoved += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsRemoved);
+      InputVariables.ItemsReplaced += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsReplaced);
+      foreach (var item in InputVariables)
+        item.ValueChanged += new EventHandler(InputVariables_Value_ValueChanged);
+    }
+
+    private void DeregisterInputVariablesEventHandlers() {
+      InputVariables.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_CollectionReset);
+      InputVariables.ItemsAdded -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsAdded);
+      InputVariables.ItemsRemoved -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsRemoved);
+      InputVariables.ItemsReplaced -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<HeuristicLab.Collections.IndexedItem<StringValue>>(InputVariables_ItemsReplaced);
+      foreach (var item in InputVariables) {
+        item.ValueChanged -= new EventHandler(InputVariables_Value_ValueChanged);
+      }
+    }
+
+    void InputVariables_ItemsReplaced(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<HeuristicLab.Collections.IndexedItem<StringValue>> e) {
+      foreach (var indexedItem in e.OldItems)
+        indexedItem.Value.ValueChanged -= new EventHandler(InputVariables_Value_ValueChanged);
+      foreach (var indexedItem in e.Items)
+        indexedItem.Value.ValueChanged += new EventHandler(InputVariables_Value_ValueChanged);
+      OnProblemDataChanged(e);
+    }
+
+    void InputVariables_ItemsRemoved(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<HeuristicLab.Collections.IndexedItem<StringValue>> e) {
+      foreach (var indexedItem in e.Items)
+        indexedItem.Value.ValueChanged -= new EventHandler(InputVariables_Value_ValueChanged);
+      OnProblemDataChanged(e);
+    }
+
+    void InputVariables_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<HeuristicLab.Collections.IndexedItem<StringValue>> e) {
+      foreach (var indexedItem in e.Items)
+        indexedItem.Value.ValueChanged += new EventHandler(InputVariables_Value_ValueChanged);
+      OnProblemDataChanged(e);
+    }
+
+    void InputVariables_CollectionReset(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<HeuristicLab.Collections.IndexedItem<StringValue>> e) {
+      foreach (var indexedItem in e.OldItems)
+        indexedItem.Value.ValueChanged -= new EventHandler(InputVariables_Value_ValueChanged);
+
+      OnProblemDataChanged(e);
+    }
+    void InputVariables_Value_ValueChanged(object sender, EventArgs e) {
+      OnProblemDataChanged(e);
+    }
+
     #endregion
 
@@ -147,8 +299,17 @@
       TargetVariable = new StringValue(Dataset.VariableNames.First());
       InputVariables = new ItemList<StringValue>(Dataset.VariableNames.Skip(1).Select(s => new StringValue(s)));
+      int middle = (int)(csvFileParser.Rows * 0.5);
       TrainingSamplesStart = new IntValue(0);
-      TrainingSamplesEnd = new IntValue(csvFileParser.Rows);
-      TestSamplesStart = new IntValue(0);
+      TrainingSamplesEnd = new IntValue(middle);
+      TestSamplesStart = new IntValue(middle);
       TestSamplesEnd = new IntValue(csvFileParser.Rows);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      DataAnalysisProblemData clone = (DataAnalysisProblemData)base.Clone(cloner);
+      clone.variables = (VariableCollection)variables.Clone(cloner);
+
+      clone.RegisterEventHandlers();
+      return clone;
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3442)
@@ -26,4 +26,6 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -33,13 +35,13 @@
   [Item("DataAnalysisSolution", "Represents a solution for a data analysis problem which can be visualized in the GUI.")]
   [StorableClass]
-  public sealed class DataAnalysisSolution : Item {
+  public class DataAnalysisSolution : Item {
     [Storable]
-    private IPredictor predictor;
-    public IPredictor Predictor {
-      get { return predictor; }
+    private IModel model;
+    public IModel Model {
+      get { return model; }
       set {
-        if (predictor != value) {
-          predictor = value;
-          OnPredictorChanged();
+        if (model != value) {
+          model = value;
+          OnModelChanged();
         }
       }
@@ -52,19 +54,42 @@
       set {
         if (problemData != value) {
+          if (value == null) throw new ArgumentNullException();
           if (problemData != null) DeregisterProblemDataEvents();
           problemData = value;
-          if (problemData != null) RegisterProblemDataEvents();
+          RegisterProblemDataEvents();
           OnProblemDataChanged();
         }
       }
     }
-    
+
+    private List<double> estimatedValues;
+    public IEnumerable<double> EstimatedValues {
+      get {
+        return estimatedValues;
+      }
+    }
+
+    private List<double> estimatedTrainingValues;
+    public IEnumerable<double> EstimatedTrainingValues {
+      get {
+        return estimatedTrainingValues;
+      }
+    }
+
+    private List<double> estimatedTestValues;
+    public IEnumerable<double> EstimatedTestValues {
+      get {
+        return estimatedTestValues;
+      }
+    }
+
     public DataAnalysisSolution() : base() { }
-    public DataAnalysisSolution(DataAnalysisProblemData problemData, IPredictor predictor)
+    public DataAnalysisSolution(DataAnalysisProblemData problemData, IModel model)
       : this() {
       this.problemData = problemData;
-      this.predictor = predictor;
+      this.model = model;
       Initialize();
     }
+
     [StorableConstructor]
     private DataAnalysisSolution(bool deserializing) : base(deserializing) { }
@@ -75,8 +100,27 @@
     }
 
+    private void RecalculateEstimatedValues() {
+      estimatedValues = GetEstimatedValues(0, problemData.Dataset.Rows).ToList();
+      int nTrainingValues = problemData.TrainingSamplesEnd.Value - problemData.TrainingSamplesStart.Value;
+      estimatedTrainingValues = estimatedValues.Skip(problemData.TrainingSamplesStart.Value).Take(nTrainingValues).ToList();
+      int nTestValues = problemData.TestSamplesEnd.Value - problemData.TestSamplesStart.Value;
+      estimatedTestValues = estimatedValues.Skip(problemData.TestSamplesStart.Value).Take(nTestValues).ToList();
+    }
+
+    private IEnumerable<double> GetEstimatedValues(int start, int end) {
+      double[] xs = new double[ProblemData.InputVariables.Count];
+      for (int row = 0; row < ProblemData.Dataset.Rows; row++) {
+        for (int i = 0; i < xs.Length; i++) {
+          var variableIndex = ProblemData.Dataset.GetVariableIndex(ProblemData.InputVariables[i].Value);
+          xs[i] = ProblemData.Dataset[row, variableIndex];
+        }
+        yield return model.GetValue(xs);
+      }
+    }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       DataAnalysisSolution clone = new DataAnalysisSolution();
       cloner.RegisterClonedObject(this, clone);
-      clone.predictor = (IPredictor)cloner.Clone(predictor);
+      clone.model = (IModel)cloner.Clone(model);
       clone.problemData = problemData;
       clone.Initialize();
@@ -85,7 +129,8 @@
 
     #region Events
-    public event EventHandler PredictorChanged;
-    private void OnPredictorChanged() {
-      var changed = PredictorChanged;
+    public event EventHandler ModelChanged;
+    private void OnModelChanged() {
+      RecalculateEstimatedValues();
+      var changed = ModelChanged;
       if (changed != null)
         changed(this, EventArgs.Empty);
@@ -93,4 +138,5 @@
     public event EventHandler ProblemDataChanged;
     private void OnProblemDataChanged() {
+      RecalculateEstimatedValues();
       var changed = ProblemDataChanged;
       if (changed != null)
@@ -99,11 +145,11 @@
 
     private void RegisterProblemDataEvents() {
-      ProblemData.DatasetChanged += new EventHandler(ProblemData_DataSetChanged);
+      ProblemData.ProblemDataChanged += new EventHandler(ProblemData_Changed);
     }
     private void DeregisterProblemDataEvents() {
-      ProblemData.DatasetChanged += new EventHandler(ProblemData_DataSetChanged);
+      ProblemData.ProblemDataChanged += new EventHandler(ProblemData_Changed);
     }
 
-    private void ProblemData_DataSetChanged(object sender, EventArgs e) {
+    private void ProblemData_Changed(object sender, EventArgs e) {
       OnProblemDataChanged();
     }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Dataset.cs	(revision 3442)
@@ -36,5 +36,5 @@
   public sealed class Dataset : NamedItem, IStringConvertibleMatrix {
     public Dataset()
-      : this(new string[0], new double[,] { { } }) {
+      : this(new string[1] { "y" }, new double[,] { { 0.0 } }) {
     }
 
@@ -45,6 +45,6 @@
         throw new ArgumentException("Number of variable names doesn't match the number of columns of data");
       }
-      Data = data;
-      this.VariableNames = variableNames;
+      this.data = data;
+      this.variableNames = variableNames.ToArray();
       this.SortableView = false;
     }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3442)
@@ -93,9 +93,10 @@
     <Compile Include="Evaluators\SimpleMSEEvaluator.cs" />
     <Compile Include="HeuristicLabProblemsDataAnalysisPlugin.cs" />
-    <Compile Include="Interfaces\IPredictor.cs" />
+    <Compile Include="Interfaces\IModel.cs" />
     <Compile Include="MatrixExtensions.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Symbolic\ArithmeticExpressionGrammar.cs" />
     <Compile Include="Symbolic\SimpleArithmeticExpressionEvaluator.cs" />
+    <Compile Include="Symbolic\SymbolicSimplifier.cs" />
     <Compile Include="Symbolic\Symbols\Constant.cs" />
     <Compile Include="Symbolic\Symbols\ConstantTreeNode.cs" />
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IModel.cs	(revision 3442)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IModel.cs	(revision 3442)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IModel : IDeepCloneable {
+    double GetValue(double[] xs);
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3442)
@@ -35,14 +35,4 @@
   public class ArithmeticExpressionGrammar : DefaultSymbolicExpressionGrammar {
     [Storable]
-    private List<string> variableNames = new List<string>();
-    public IEnumerable<string> VariableNames {
-      get { return variableNames; }
-      set {
-        variableNames = new List<string>(value);
-        variableSymbol.VariableNames = variableNames;
-      }
-    }
-
-    [Storable]
     private HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols.Variable variableSymbol;
 
@@ -58,4 +48,6 @@
       var div = new Division();
       var constant = new Constant();
+      constant.MinValue = -20;
+      constant.MaxValue = 20;
       variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols.Variable();
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs	(revision 3441)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionEvaluator.cs	(revision 3442)
@@ -44,5 +44,5 @@
         this.row = row;
         pc = 0;
-        arguments.Clear();
+        argumentStack.Clear();
         var estimatedValue = Evaluate();
         if (double.IsNaN(estimatedValue) || double.IsInfinity(estimatedValue)) yield return 0.0;
@@ -51,5 +51,5 @@
     }
 
-    private List<double> arguments = new List<double>();
+    private Stack<List<double>> argumentStack = new Stack<List<double>>();
     public double Evaluate() {
       var currentInstr = code[pc++];
@@ -85,10 +85,10 @@
         case CodeSymbol.Call: {
             // save current arguments
-            var oldArgs = new List<double>(arguments);
-            arguments.Clear();
+            List<double> arguments = new List<double>();
             // evaluate sub-trees
             for (int i = 0; i < currentInstr.nArguments; i++) {
               arguments.Add(Evaluate());
             }
+            argumentStack.Push(arguments);
             // save the pc
             int nextPc = pc;
@@ -97,12 +97,11 @@
             // evaluate the function
             double v = Evaluate();
+            argumentStack.Pop();
             // restore the pc => evaluation will continue at point after my subtrees  
             pc = nextPc;
-            // restore arguments
-            arguments = oldArgs;
             return v;
           }
         case CodeSymbol.Arg: {
-            return arguments[currentInstr.iArg0];
+            return argumentStack.Peek()[currentInstr.iArg0];
           }
         case CodeSymbol.Dynamic: {
